/***************************************************************
   Plik "main.c"

   KURS AVR-GCC (abxyz.bplaced.net)
 
   nadajnik  RC5
 
   (schemat i opis dziaania w artykule)
   testowanie na atmega8 (8MHz)
*****************************************************************/

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>


typedef unsigned char  u8;
typedef  unsigned int  uint;

//---------------------------------------------------------------
// Funkcja wysya komend  RC5                                             
//---------------------------------------------------------------
 void send_cmd(uint cmd)
 {
    uint m;

    // docza 2 bity startowe 
    cmd |= (3<<12); 

    for(m=(1<<13); m>0; m>>=1)
    {
       if(cmd & m)// jeli bit o wartoci 1
       {   
           // Dioda nadawcza  nie wieci 
           TCCR2= (1<<FOC2)|(1<<COM21)|(1<<CS20); 
           _delay_ms(0.89); // czas trwania poowy bitu 
           // wieci 
           TCCR2= (1<<FOC2)|(1<<WGM21)|(1<<COM20)|(1<<CS20); 
           _delay_ms(0.89);
       }
       else // jeli bit o wartoci 0 
       {   
           // Dioda nadawcza wieci  
           TCCR2= (1<<FOC2)|(1<<WGM21)|(1<<COM20)|(1<<CS20); 
           _delay_ms(0.89);
           // Nie wieci 
           TCCR2= (1<<FOC2)|(1<<COM21)|(1<<CS20); 
           _delay_ms(0.89);
       } 
    }
    TCCR2= (1<<FOC2)|(1<<COM21)|(1<<CS20); // wyczamy LED i timer2
    TCCR2= 0;  
   
 }

//---------------------------------------------------------------
// GLWNA FUNKCJA PROGRAMU                                                   
//---------------------------------------------------------------
int main(void)
{
   u8  i,cmd;
   u8 toggle = 0 ;  

   // PB3(OC2) wyjcie - dioda nadawcza podczerwieni 
   DDRB = (1<<PB3);

   // Timer2, CTC mode, no prescaling ,Toggle OC2 on compare match 
   // TCCR2= (1<<WGM21)|(1<<COM20)|(1<<CS20);   
   // OC2 - 36 KHz
   OCR2 = 110; 
 
   while(1)
     // Wysya po kolei wszystkie komendy 
     for(i=0; i<64; i++)
     {
        // do kolejnej komendy dostawia toggle bit
        cmd =  i|((toggle & 0x01)<<11);
        toggle++;
  
        // Wysya  komend 
        send_cmd(cmd); 
        _delay_ms(89); // 50 bitw "ciszy"

        // Komendy wysyamy sobie co sekund 
        _delay_ms(1000);  
     }

   return 0;
}



